﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Mediachase.Search.Providers.Solr35
{
    /// <summary>
    /// The interface expected to be returned by the query builder.
    /// </summary>
    public interface ISolrSearchQuery
    {
        /// <summary>
        /// An enumeration of key-value pairs of parameters to send to the search engine.
        /// </summary>
        IEnumerable<KeyValuePair<string, string>> Parameters { get; }

        /// <summary>
        /// A faceting manager to contain faceting parameters, and also assist
        /// with mapping facet counts back into a response object.
        /// </summary>
        IFacetManager Faceting { get; }

        /// <summary>
        /// Adds a parameter to the <see cref="M:ISolrSearchQuery.Parameters"/> collection.
        /// </summary>
        /// <param name="name">The name of the parameter.</param>
        /// <param name="value">The value of the parameter.</param>
        void AddParameter(string name, string value);

    }
}
