﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Mediachase.Search.Providers.Solr35.Select
{
    internal class MultiValueFieldQuery : QueryPart
    {
        private readonly string _fieldName;
        private readonly List<string> _values;

        public MultiValueFieldQuery(string fieldName, IEnumerable<string> values)
        {
            _fieldName = fieldName;
            _values = values.Select(SolrSearchQueryBuilder.EscapeValueString).ToList();
        }

        public override bool HasContent()
        {
            return true;
        }

        public override void AppendTo(StringBuilder builder)
        {
            builder.Append(String.Join(" OR ", _values.Select(x => String.Format("{0}:{1}", _fieldName, x))));
        }
    }
}
